/******************************************************************************
 *
 * Copyright (c) 1999	TOSHIYUKI ARAI. ALL RIGHTS RESERVED. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer.
 *  
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *	DIBitmap.h
 *
 *****************************************************************************/

// SOL++2000

#ifndef _SOL_GDIOBJECT
#include <sol\GdiObject.h>
#endif

#ifndef _SOL_PALETTE
#include <sol\Palette.h>
#endif

#ifndef _SOL_DIBITMAP
#define _SOL_DIBITMAP

typedef HANDLE HDIB;

class DIBitmap :public GdiObject {
	int		sx, sy;
	int		width;
	int		height;
	int		colors;
	int		destroy;
	Palette* palette;
	BOOL	createPalette(HDIB hdib);
  public:
	DIBitmap(const char* name, HDIB hdib, int w, int h, int ncolors);
	~DIBitmap();
	void	draw(HDC hdc, int x, int y);
	void	draw(DC& dc, int x, int y);

	void	getSize(int& w, int& h) { w=width; h=height; }
	void	setSource(int x, int y);
	Palette* getPalette() { return palette; }

};

#endif
