/******************************************************************************
 *
 * Copyright (c) 1999	TOSHIYUKI ARAI. ALL RIGHTS RESERVED. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer.
 *  
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *	Pair.h
 *
 *****************************************************************************/


// SOL++2000 
// 2000.02.18

#ifndef _SOL_NODE
#include <sol\Node.h>
#endif

#ifndef _SOL_STRING
#include <sol\String.h>
#endif

#ifndef _SOL_PAIR
#define _SOL_PAIR

class Pair :public Object {
	Node*	parent;
	Node*   child;
	String	name;
	int		line;
  public:
	Pair(Node* parent, Node* child) {
		this->parent = parent;
		this->child  = child;
		line = 0;
	}
	~Pair() {
		delete parent;
		delete child;
	}
	char* getParentName() {
		if(parent) {
			return parent->getName();
		}
		else {
			return NULL;
		}
	}
	char* getChildName() {
		if(child) {
			return child->getName();
		}
		else {
			return NULL;
		}
	}

	Node* getParentNode() {
		return parent;
	}
	Node* getChildNode() {
		return child;
	}
	void	setName(char* name1) {
		this->name = name1;	
	}

	char*	getName() {
		return (char*)(name);
	}
	void	setLine(int line) {
		this->line = line;
	}
	int		getLine() {
		return line;
	}
};

#endif

