/******************************************************************************
 *
 * Copyright (c) 1999	TOSHIYUKI ARAI. ALL RIGHTS RESERVED. 
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer.
 *  
 * 2. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR 
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF 
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *
 *	HTMLElement.h
 *
 *****************************************************************************/


#ifndef _SOL_OBJECT
#include <sol\Object.h>
#endif

#ifndef _SOL_STRING
#include <sol\String.h>
#endif
#ifndef _SOL_STDIO
#include <sol\Stdio.h>
#endif

#ifndef _SOL_LINKEDLIST
#include <sol\LinkedList.h>
#endif
#ifndef _SOL_HTMLATTRIBUTE
#include "HTMLAttribute.h"
#endif

#ifndef _SOL_HTMLELEMENT
#define _SOL_HTMLELEMENT

class HTMLElement :public Object {
	String	name;
	LinkedList list;
public:
	HTMLElement() {
	}
	void	setName(const char* string) {
		name = string;
	}

	void addAttribute(const char* attrName, const char* attrValue) {
		list.add(new HTMLAttribute(attrName, attrValue));
	}
	void clear() {
		list.clear();
	}

	LinkedList& getAttributeList() {
		return list;
	}
	void print() {
		Printf("%s\r\n", (const char*)name);
	}
};

#endif
